﻿$(document).ready(function () {

    var tempBuffer = "";
    var g_index = "";
    var nMode = 0;// 0 - New; 1 - Edit

    var $datatablesFixedheader = $('#datatables-scroller-1');
    if ($datatablesFixedheader.length) {
        $datatablesFixedheader = $datatablesFixedheader.DataTable({
            deferRender: true,
            responsive: true,
            dom: "<'row'<'col-sm-6'i><'col-sm-6'f>>" + "<'row'<'col-sm-12'tr>>" + "<'row'<'col-sm-6'l><'col-sm-6'p>>",
            language: {
                paginate: {
                    previous: '&laquo;',
                    next: '&raquo;'
                },
                search: "_INPUT_",
                searchPlaceholder: "Search…"
            },
            order: [[6, 'asc']],
            rowGroup: {
                dataSrc: 6
            },
            "columnDefs": [
            {
                "targets": [6],
                "visible": false
            }
            ]
        });

        $(window).on('resize', function (evt) {
            setTimeout(function () {
                $datatablesFixedheader.columns.adjust().responsive.recalc();
            }, 150);
        });
    }

    
    // The following code creates the list of the existing groups when performing the entry of a new password
    $('#group').select2({
        tags: true,
        tokenSeparators: [',', ';'],
        dir: 'ltr',
        allowClear: true,
        placeholder: "Select an existing group or enter a new group"
    }).trigger('change');

    for (i = 0; i < arrGroupList.length; i++) {
        var bSelected = false;
        var areEqual = arrGroupList[i].toLowerCase().trim() === strGroupName.toLowerCase().trim();
        if (areEqual == true) {
            bSelected = true;
            break;
        }
        $('#group').append($("<option/>", {
            value: arrGroupList[i],
            text: arrGroupList[i],
            selected: bSelected
        }));
    }

    // Function to handle addition of new password entry
    $("#btnAddPasswordEntry").click(function () {
        // Check if the user has entered the group
        

        var strGroup = $("#group").val();
        if (strGroup != undefined && strGroup.trim() != '') {
            var strDescription = $("#description").val();
            var strURL = $("#url").val();
            var strLoginID = $("#loginid").val();
            var strPassword1 = $("#password1").val();
            var strPassword2 = $("#password2").val();
            // check if the two passwords match
            if (strPassword1 == strPassword2) {
                // Create overlay and append to body:
                $('<div id="overlay"/>').css({
                    position: 'fixed',
                    top: 0,
                    left: 0,
                    width: '100%',
                    height: $(window).height() + 'px',
                    background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
                    opacity: 0.90
                }).hide().appendTo('body');
                var strExpiry = $("#expiry").data('datepicker').getFormattedDate('yyyy-mm-dd');
                var strNotes = $("#notes").val();

                $('#overlay').show();

                if (g_index == "" || g_index == undefined)
                {
                    g_index = -1;
                }
                // Lets add the password to the list using AJAX
                $.post("/PAM/add",
                    {
                        "index":g_index,
                        "group": strGroup,
                        "description": strDescription,
                        "url": strURL,
                        "loginid": strLoginID,
                        "password": strPassword1,
                        "expiry": strExpiry,
                        "notes": strNotes,
                        "mode": nMode
                    })
                   .done(function (data) {
                       $('#overlay').hide();
                       var obj = jQuery.parseJSON(data);
                       if (obj.result == "true") {
                           // Added the password, so lets refresh the screen
                           location.reload();
                       }
                       else {
                           $("#errorMessage").text(obj.message);
                       }
                   })
                  .fail(function () {
                      $('#overlay').hide();
                      alert("error");
                  });
            }
            else {
                $("#errorMessage").text("The passwords you have entered do not match");
            }
        }
        else {
            $("#errorMessage").text("Please enter a group or select a existing group");
        }
    });

   

    // This function is called when the user selects to copy the login id
    $(".loginidCopy").click(function () {
        var index = this.getAttribute("data-index");
        var spanElement = $("#lid_" + index);
        strLoginID = spanElement.text();
        fnCopyToClipboard(strLoginID, "Login ID");
        return false;
    });

    // This function is called when the user selects to copy the password
    $(".passwordCopy").click(function () {
        // get status of the button
        g_index = this.getAttribute("data-index");
        var spanElement = $("#pass_" + g_index);
        var data = this.getAttribute("data-pass");
        if (data == undefined || data == "") {
            // Password fetch mode
            this.setAttribute("disabled", true);
            spanElement.text("Retrieving...");


            // Lets add the password to the list using AJAX
            $.post("/PAM/gp",
                {
                    "index": g_index
                }).done(function (data) {
                    var obj = jQuery.parseJSON(data);
                    if (obj.result == "true") {
                        // Lets get the password from the received text
                        var buttonIndex = g_index;
                        tempBuffer = obj.data;
                        spanElement.text("Click To Copy");
                        $("#btn_" + buttonIndex).attr("data-pass", tempBuffer);
                        $("#btn_" + buttonIndex).attr("disabled", false);
                        $("#btn_" + buttonIndex).removeClass("arrow-outline-default").addClass("arrow-primary");

                        var nCount = 10;
                        var intervalID = setInterval(function () {
                            $("#btn_" + buttonIndex).attr("data-interval_id", intervalID);
                            spanElement.text("Click To Copy [" + nCount.toString() + "]");
                            nCount--;
                            if (nCount < 0) {
                                clearInterval(intervalID);
                                spanElement.text("Obtain");
                                $("#btn_" + buttonIndex).removeClass("arrow-primary").addClass("arrow-outline-default");
                                $("#btn_" + buttonIndex).attr("data-pass", "");
                                $("#btn_" + buttonIndex).attr("data-interval_id", "");
                                $("#btn_" + buttonIndex).blur();
                            }
                        }, 1000);

                    }
                    else {
                        tempBuffer = "";
                        $("#btn_" + g_index).attr("disabled", false);
                        spanElement.text("Obtain");
                        var options = {};
                        options['closeButton'] = true;
                        options['positionClass'] = "toast-top-center";
                        options['type'] = "error";
                        var title = "Error getting password";
                        toastr[options.type](obj.message, title, options);

                    }
                }).fail(function () {
                    $("#btn_" + g_index).attr("disabled", false);
                    spanElement.text("Obtain");
                    var options = {};
                    options['closeButton'] = true;
                    options['positionClass'] = "toast-top-center";
                    options['type'] = "error";
                    var title = "Error";
                    toastr[options.type]("Unable to perform retrieval of the password at the moment, please try later.", title, options);
                });
        }
        else
        {
            // Password exists so lets copy to clipboard
            fnCopyToClipboard(data, "Password");
        }

        return false;
    });

    // Function to remove a password from the list
    $(".btnRemove").click(function () {
        g_index = this.getAttribute("data-index");
        // Lets confirm from the user if he wants to really delete the password.
        $("#modalDeletePAMEntryConfirmation").modal('toggle');
    });

    // Function to handle deleting the PAM entry
    $(".deletePairing").click(function () {
        // Lets call the ajx to remove he password
        $.post("/PAM/rp",
            {
                "index": g_index
            }).done(function (data) {
                var obj = jQuery.parseJSON(data);
                if (obj.result == "true") {
                    location.reload();
                }
                else {
                    var options = {};
                    options['closeButton'] = true;
                    options['positionClass'] = "toast-top-center";
                    options['type'] = "error";
                    var title = "Error removing PAM entry";
                    toastr[options.type](obj.message, title, options);

                }
            }).fail(function () {
                var options = {};
                options['closeButton'] = true;
                options['positionClass'] = "toast-top-center";
                options['type'] = "error";
                var title = "Error removing PAM entry";
                toastr[options.type]("Unable to perform removal of the entry at the moment, please try later.", title, options);
            });
    });

    // This function copies the passed data to the clipboard
    function fnCopyToClipboard(strData, type) {
        var $temp = $("<input>");
        $("body").append($temp);
        $temp.val(strData).select();
        document.execCommand("copy");
        $temp.remove();

        var options = {};
        options['closeButton'] = true;
        options['positionClass'] = "toast-top-center";
        options['type'] = "success";
        var title = "";
        toastr[options.type](type + " copied to clipboard", title, options);
    }

    // Function to handle event for addition of new PAM Entry
    $(".addNewPAMEntry").click(function () {
        nMode = 0;
        $("#group").val('').trigger('change');
        $("#description").val('');
        $("#url").val('');
        $("#loginid").val('');
        $("#password1").val('');
        $("#password2").val('');
        $("#expiry").val('');
        $("#notes").val('');
        $("#btnAddPasswordEntry").text("Add");
        $("#modalAddNewPAMEntry").modal('toggle');
        return false;
    });

    // Function to perform editing of the entry
    $(".editEntry").click(function () {
        // get status of the button
        g_index = this.getAttribute("data-index");
        if (g_index != undefined && g_index != "") {
            
            // Lets add the password to the list using AJAX
            $.post("/PAM/gd",
                {
                    "index": g_index
                }).done(function (data) {
                    var obj = jQuery.parseJSON(data);
                    if (obj.result == "true") {
                        // lets get the data and show in the edit dialog
                        var objData = obj.data;
                        if(objData != undefined)
                        {
                            $("#group").val(objData.group).trigger('change');
                            $("#description").val(objData.description);
                            $("#url").val(objData.url);
                            $("#loginid").val(objData.loginid);
                            $("#password1").val(objData.password);
                            $("#password2").val(objData.password);
                            $("#expiry").datepicker({
                                format: 'yyyy-mm-dd',
                                date: objData.expiry
                            });

                            $("#notes").val(objData.notes);

                            
                            // Set the dialog in edit mode
                            nMode = 1;
                            $("#btnAddPasswordEntry").text("Update");
                            $("#modalAddNewPAMEntry").modal('toggle');
                        }
                        else {
                            var options = {};
                            options['closeButton'] = true;
                            options['positionClass'] = "toast-top-center";
                            options['type'] = "error";
                            var title = "Error";
                            toastr[options.type]("Unable to perform retrieval of the data for editing at the moment, please try later.", title, options);
                        }
                    }
                    else {
                        var options = {};
                        options['closeButton'] = true;
                        options['positionClass'] = "toast-top-center";
                        options['type'] = "error";
                        var title = "Error getting data";
                        toastr[options.type](obj.message, title, options);

                    }
                }).fail(function () {
                    var options = {};
                    options['closeButton'] = true;
                    options['positionClass'] = "toast-top-center";
                    options['type'] = "error";
                    var title = "Error";
                    toastr[options.type]("Unable to perform retrieval of the data for editing at the moment, please try later.", title, options);
                });
        }
        return false;
    });

    
});

// Function to toggle the view of the password
function fnToggle(id) {
    if (id != undefined && id != "") {
        var currentType = $("#" + id).attr("type");
        if (currentType == 'password') {
            $("#" + id).attr("type", "text");
        }
        else {
            $("#" + id).attr("type", "password");
        }
    }
}